class Settings::BenchmarkInfosController < SettingsController
  def index
    @benchmark_info = BenchmarkInfo.new
  end

  def show
    @benchmark_info = BenchmarkInfo.find(params[:id])
  end

  def create
    @benchmark_info = BenchmarkInfo.new(benchmark_params)

    if @benchmark_info.save
      flash[:success] = "Benchmark #{@benchmark_info.name} successfully created"
      redirect_to action: :index
    else
      flash.now[:failure] = "There were some errors" 
      render "index"
    end
  end

  def update
    @Benchmark_info = BenchmarkInfo.find(params[:id])

    if @benchmark_info.update_attributes(benchmark_params)
      flash[:success] = "Benchmark #{@benchmark_info.name} successfully updated"
      redirect_to action: :index
    else
      flash.now[:failure] = "There were some errors" 
      render "show"
    end
  end


  def destroy
    @benchmark_info = BenchmarkInfo.find(params[:id])

    if @benchmark_info.destroy
      flash[:success] = "Benchmark #{@benchmark_info.name} successfully deleted"
    else
      flash[:error] = "Could not delete #{@benchmark_info.name} benchmark"
    end

    redirect_to action: :index
  end

  private

  def benchmark_params
    params.require(:benchmark_info).permit(:benchmark_selector, :benchmark_class, :description)
  end
end
